#include <stdio.h>
#include <wiringPi.h>
#include "io.h"

// ピン配置
//static const int pin_sw_f  = 25;
//static const int pin_sw_l  = 21;
//static const int pin_sw_r  = 27;
static const int pin_sw_fl  = 18;
static const int pin_sw_fr  = 23;
static const int pin_sw_bl  = 25;
static const int pin_sw_br = 24;

int io_open(){
	// GPIOデバイスのオープン
	if(wiringPiSetupGpio() != 0){
		printf("failed to open GPIO\n");
		return -1;
	}else{
		// ピン設定
		pinMode(pin_sw_fl, INPUT);
		pinMode(pin_sw_fr, INPUT);
		pinMode(pin_sw_bl, INPUT);
		pinMode(pin_sw_br, INPUT);
		pullUpDnControl(pin_sw_fl, PUD_UP);
		pullUpDnControl(pin_sw_fr, PUD_UP);
		pullUpDnControl(pin_sw_bl, PUD_UP);
		pullUpDnControl(pin_sw_br, PUD_UP);
		
		printf("GPIO opened\n");
		return 0;
	}
}

void io_get_sw(int *sw_fl, int *sw_fr, int *sw_bl,int *sw_br){
	*sw_fl = digitalRead(pin_sw_fl);
	*sw_fr = digitalRead(pin_sw_fr);
	*sw_bl = digitalRead(pin_sw_bl);
	*sw_br = digitalRead(pin_sw_br);
}
