#include <stdio.h>
#include <unistd.h>
#include "arduino.h"
#include "io.h"
#include "request.h"
#include "uss.h"
#include "route.h"
#include "python.h"

#define KP 							0.0002//0.0012
#define KD							0.0004
#define KI							0.0000//0.0002
#define DELTA_T 			0.3
#define IGNORE_DIFF		30
#define L_R_RATIO		0.008
#define SPEED					50



run_state_t state;


double turn;
double diff[5];
double right[5];
double left[5];
double diffSum;
double averageDiff,averageLeft,averageRight;
int speed;
int ignore,ignoreRight,ignoreLeft,trueRight,trueLeft;
int dist,distance;
int nextMove;
int stop = 0;
int sw_fl,sw_fr,sw_bl,sw_br;
int current;
int slow=0;
int run = 0;
int here;

void run_init(){
        run = 0;
        int i;
        int said = 0;
        turn = 1.007;
        python_write(6);
        usleep(3000000);
        request_set_runmode(TUR, (int)(turn*1000), 10);
        usleep(100000);
        request_set_runmode(STR,SPEED,1500);
        while(1){
            request_get_runmode(&state,&speed,&dist);
            if (dist > 770){
                break;
            }
            usleep(100000);
        }
        python_write(9);
        request_set_runmode(STR,0,1500);
        usleep(1000000);
        request_set_runmode(ROT,20,-68);
        usleep(5000000);
        request_set_runmode(STR,SPEED,1500);
        while(1){
            request_get_runmode(&state,&speed,&dist);
            if (uss_get_val(0) >0 && uss_get_val(0) < 150){
                break;
            }
            usleep(100000);
        }
        request_set_runmode(STR,0,1500);
        python_write(7);
        for(i=0 ; i < 4 ;i++){
            usleep(1000000);
            printf("%d \n",i);
        }
        python_write(8);
        for(i=0 ; i < 5 ;i++){
            usleep(1000000);
            printf("%d \n",i);
        }
        
        request_set_runmode(ROT,20,136);
        usleep(10000000);
        request_set_runmode(STR,SPEED,1500);
        while(1){
            request_get_runmode(&state,&speed,&dist);
            if (uss_get_val(0) >0 && uss_get_val(0) < 150){
                break;
            }
            usleep(100000);
        }
        
        stop = 1;
         /*for(i=0 ; i < 10 ;i++){
            usleep(1000000);
            printf("%d \n",i);
        }
        python_write(2);
        for(i=0 ; i < 13 ;i++){
            usleep(1000000);
            printf("%d \n",i);
        }
        python_write(3);
        for(i=0 ; i < 10 ;i++){
            usleep(1000000);
            printf("%d \n",i);
        }*/
        
		//request_set_runmode(STR,SPEED,10000);
		//stop = 0;
		ignoreRight = 0;
		ignoreLeft = 0;
        here = 9;
        //route_set_route(11,9);
        current = 0;
        //python_write(0);
        turn = 1.0;
        python_first_read();
}

void run_operate(int operation) {
    
    if (operation >=90) {
        if (operation == 90) {
            request_set_runmode(ROT,300,248);
            usleep(2000000);
            request_set_runmode(ROT,300,-248);
            usleep(2000000);
        }
    } else if (run == 0) {
        printf("operate %d run %d",operation,run);
        //request_set_runmode(ROT,20,128);
		//usleep(10000000);
        route_set_route(here,operation);
        request_set_runmode(STR,SPEED,10000);
        
        current = 0;
        run = 1;
        here = operation;
        
        
        
    }
    
}

void run_run(){
    
    int i;
    
	if (flag == 1) {
		run_set_turn();
		flag = 0;
	}

	request_get_runmode(&state,&speed,&dist);
    
    if (route_get_turn(current) == 1 || route_get_turn(current) == 2) {
        if (route_get_distance(current)-dist < 300) {
            slow = 1;
            request_set_runmode(STR,30,10000);
            python_write(4);
        }
    }
    
    if (slow == 1 && route_get_turn(current) == 1 && right[0] >= 200 && right[1] >= 200 && right[2] >= 200&& right[3] >= 200 && right[4] >= 200) {
        slow = 0;
        turn = 1.0;
		request_set_runmode(TUR, (int)(turn*1000), 10);
        usleep(100000);
		request_set_runmode(STP, 0, 0);
		usleep(100000);
		request_set_runmode(ROT,20,-68);
		usleep(7000000);
		turn = 1.0;
		request_set_runmode(TUR, (int)(turn*1000), 10);					//右へのターン
		usleep(1000000);
		request_set_runmode(STR,SPEED,10000);
		usleep(1000000);
		current++;
		for(i = 0;i < 5;i++) {
			right[i] = 100;
			left[i] = 100;
		}
		
	} else if (slow == 1 && route_get_turn(current) == 2 && left[0] >= 200 && left[1] >= 200 && left[2] >= 200 && left[3] >= 200 && left[4] >= 200) {
        slow = 0;
        turn = 1.0;
		request_set_runmode(TUR, (int)(turn*1000), 10);
        usleep(100000);
		request_set_runmode(STP, 0, 0);
		usleep(100000);
		request_set_runmode(ROT,20,68);
		usleep(7000000);
		turn = 1.0;
		request_set_runmode(TUR, (int)(turn*1000), 10);					//右へのターン
        usleep(1000000);
		request_set_runmode(STR,SPEED,10000);
		usleep(1000000);
		current++;
		for(i = 0;i < 5;i++) {
			right[i] = 100;
			left[i] = 100;
		}
		
	} else if (route_get_turn(current) == 0 && dist > route_get_distance(current)) {
        current++;
        request_set_runmode(STR,SPEED,10000);
    } else if (route_get_turn(current) == 5 && dist > route_get_distance(current)) {
        request_set_runmode(STR,0,10000);
        run = 0;
        python_write(0);
    } else if (route_get_turn(current) == 14 && dist > route_get_distance(current)) {
        request_set_runmode(STR,0,10000);
        current++;
        python_write(1);
        int i;
        for(i=0 ; i < 10 ;i++){
            usleep(1000000);
            printf("%d \n",i);
        }
        python_write(5);
        for(i=0 ; i < 10 ;i++){
            usleep(1000000);
            printf("%d \n",i);
        }
        
        request_set_runmode(STR,SPEED,10000);
    } else if (route_get_turn(current) == 15 && dist > route_get_distance(current)) {
        //left[0] = 0;
        //left[1] = 0;
        //left[2] = 0;
        //left[3] = 0;
        current++;
    }  else if (route_get_turn(current) == 16 && dist > route_get_distance(current)) {
        //right[0]= 0; 
        //right[1]= 0;
        //right[2]= 0;
        //right[3]= 0;
        current++;
    }
	io_get_sw(&sw_fl,&sw_fr,&sw_bl,&sw_br);
	//printf("turn %6d left %d right %d ignoreLeft %d ignoreRight %d Speed %d \n",(int)(turn*1000),uss_get_val(2),uss_get_val(3),ignoreLeft,ignoreRight,speed);
    
    printf("speed %d dist %d target %d\n",speed,dist,route_get_distance(current));
    
	if (sw_fl == 0||sw_fr ==0||sw_bl == 0||sw_br==0 || uss_get_val(0) >0 && uss_get_val(0) < 100) {
		stop = 1;
	}
}

void run_set_turn() {
	ignore = 0;
	//uss_get();
	int i;
	for(i=4;i>0;i--) {
		diff[i] = diff[i-1];
		left[i] = left[i-1];
		right[i] = right[i-1];
	}
	
	right[0] = uss_get_val(3);
	left[0] = uss_get_val(2);
	averageRight = (right[1]+right[2]+right[3]+right[4]) / 4;
	averageLeft = (left[1]+left[2]+left[3]+left[4]) /4;
	if (uss_get_val(3) - averageRight < IGNORE_DIFF && uss_get_val(3)-averageRight > -IGNORE_DIFF && right[0] != -1) {
		ignoreRight = 0;
	} else	{
		if (ignoreRight == 0 ) {
			ignoreRight = 1;
			trueRight = right[1];
		}
	}
	if (uss_get_val(2) - averageLeft < IGNORE_DIFF && uss_get_val(2)-averageLeft > -IGNORE_DIFF && left[0] != -1) {
		ignoreLeft = 0;
	} else {
		if (ignoreLeft == 0) {
			ignoreLeft = 1;
			trueLeft = left[1];
		}
	}
	
	diff[0] = 0;
	if (ignoreRight == 0) {
		diff[0] += right[0];
	} else {
		diff[0] += trueRight;
	}
	if (ignoreLeft == 0) {
		diff[0] -= left[0];
	} else {
		diff[0] -= trueLeft;
	}
	
	diffSum += diff[0];
	
	turn =  1.0 +  KP*diff[0] +  KI*diffSum+ KD*(diff[0]-diff[1])/DELTA_T + L_R_RATIO;		//TURN値の計算
	
	if (turn > 1.2 ){
		turn = 1.2;
	} else if (turn < 0.8) {
		turn = 0.8;
	}
	
	//if (slow == 1) {
    //    turn = 1.0;
    //}
	
	request_set_runmode(TUR, (int)(turn*1000), 10);					//直進補正地の送信
    
   // printf("turn %d distance %d dist %d \n",route_get_turn(current),route_get_distance(current),dist);
}

int run_stop() {
	return stop;
}
