#include <stdio.h>
#include <unistd.h>
#include <wiringPiI2C.h>
#include <pthread.h>
#include "uss.h"
#include "run.h"

// 測定の時間間隔[ms]
static const int t_uss = 50;

// 測定範囲の下限・上限[cm]
static const int uss_min =  16;
static const int uss_max = 600;

// センサからMIRS中心までの距離[cm]
static const int dist_center = 10;

static const int uss_number = 6;

static int abc[6];

long val[6];
int flag = 0;

void uss_run() {
	
	while(1) {
        if (stop == 1) {
            pthread_exit(0);
        }
		//printf("uss running\n");
		uss_get();
	}
	
}

int uss_open(){
	int i;
	abc[0] = wiringPiI2CSetup(0x71);
	abc[1] = wiringPiI2CSetup(0x73);
	abc[2] = wiringPiI2CSetup(0x74);
	abc[3] = wiringPiI2CSetup(0x72);
	abc[4] = wiringPiI2CSetup(0x70);
	abc[5] = wiringPiI2CSetup(0x75);
	
	for (i = 0;i < uss_number;i++ ) {
	// ソフトウェアリビジョンの確認
		if(wiringPiI2CReadReg8(abc[i], 0x00) == 0x06){
			printf("USS opened\n");
			return 0;
		}else{
			printf("failed to open USS\n");
			return -1;
		}
	}
}

void uss_get(){
	unsigned char lowbyte, highbyte;
	
	int i;
	for (i = 0;i < uss_number;i++ ) {
		wiringPiI2CWriteReg8(abc[i], 0x00, 0x51);
		usleep(t_uss * 1000);
	}
	
	for (i = 0;i < uss_number;i++ ) {
		lowbyte  = wiringPiI2CReadReg8(abc[i], 0x03);
		highbyte = wiringPiI2CReadReg8(abc[i], 0x02);
		val[i] = lowbyte + highbyte * 256 + dist_center;
		
		if(val[i] < uss_min || val[i] > uss_max){
			val[i] = -1;
		} 
	}

	flag = 1;
}

int uss_get_val(int num) {
	return val[num];
}
